
#include <QtGui>
#include "mainwindow.h"


MainWindow::MainWindow (QWidget * parent):QMainWindow (parent)
{
  ui.setupUi (this);
  //connections

	connect(ui.textureBox,   SIGNAL(clicked(bool)), ui.glArea, SLOT(setTexturedOrWireframe(bool)) );
	connect(ui.seamlessUBut,  SIGNAL(clicked(bool)), ui.glArea, SLOT(setSeamlessTextureU(bool)) );
	connect(ui.seamlessVBut,  SIGNAL(clicked(bool)), ui.glArea, SLOT(setSeamlessTextureV(bool)) );
	connect(ui.torusBut,     SIGNAL(clicked(bool)), ui.glArea, SLOT(makeTorus()) );
	connect(ui.cylinderBut,  SIGNAL(clicked(bool)), ui.glArea, SLOT(makeCylinder()) );
	connect(ui.mipmapBut,  SIGNAL(clicked(bool)),   ui.glArea, SLOT(setMipmap(bool)) );
	connect(ui.bilinearBut,  SIGNAL(clicked(bool)),   ui.glArea, SLOT(setBilinear(bool)) );
	connect(ui.textureSelector, SIGNAL(valueChanged(int)), ui.glArea, SLOT(setTextureNumber(int)));

	connect(ui.torusBut,  SIGNAL(toggled(bool)), ui.seamlessVBut, SLOT(setEnabled(bool)) );

	connect(ui.showShaderBut, SIGNAL(clicked()), this, SLOT(showShaders()) );
	connect(ui.aboutBut, SIGNAL(clicked()), this, SLOT(aboutWindow()) );
}

void MainWindow::aboutWindow(){
	QMessageBox::about(this,"Seamless parametrization",
		"<b>Seamless parametrization demo</b><br>"
		"a CG-tool submission<br>"
		"(review in progress)<br>"
		"<br>"
		"by Marco Tarini<br>"
		"Aug 2011<br>"
		"<br>"
		"<br>"
		"<i>Info: all models are plain vertex array<br>with no vertex repetitions.</i>"
	);
}

void MainWindow::showShaders(){
	QDialog *d = new QDialog(this,Qt::Dialog);

	QPlainTextEdit* te0 = new  QPlainTextEdit(ui.glArea->getCurrentVertexShader(),d);
	QPlainTextEdit* te1 = new  QPlainTextEdit(ui.glArea->getCurrentFragmentShader(),d);
	te0->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);
	te1->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);

	d->setLayout(new QVBoxLayout(d));
	d->layout()->addWidget( new  QLabel("Vertex shader:",d));
	d->layout()->addWidget( te0 );
	d->layout()->addItem( new QSpacerItem(20, 10, QSizePolicy::Minimum, QSizePolicy::Expanding) );
	d->layout()->addWidget( new  QLabel("Fragmet shader:",d));
	d->layout()->addWidget( te1 );
	d->layout()->addItem( new QSpacerItem(20, 10, QSizePolicy::Minimum, QSizePolicy::Expanding) );
	//d->layout()->addWidget( (this) );
	QDialogButtonBox* buttonBox;
	d->layout()->addWidget( buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok) );
	connect(buttonBox, SIGNAL(accepted()), d, SLOT(accept()));

	/*d->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Expanding);*/
	d->resize(500,500);

	d->exec();

}


